unit SzogPont;

interface

uses
  SysUtils, Classes, Controls, ExtCtrls, Graphics;

type
  TSzogPont = class(TShape)
  private
    { Private declarations }
      FCaption : string;
      FFont    : TFont;
      FDown : boolean;
      Findex : integer;
      Fsmx,Fsmy:integer;
  protected
    { Protected declarations }
    Procedure Paint; override;
    Procedure SetCaption(P:String);
    Procedure SetFont(P:TFont);
    procedure setCX(p:integer);
    procedure setCY(p:integer);
    function readCX:integer;
    function readCY:integer;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
  published
    { Published declarations }
      property Caption : string read FCaption write SetCaption;
      property Font : TFont read FFont write SetFont;
      property CX : integer read readCX write setCX;
      property CY : integer read readCY write setCY;
      property isdown : boolean read FDown write FDown;
      property index: integer read Findex write Findex;
      property smx:integer read Fsmx write Fsmx;
      property smy : integer read Fsmy write Fsmy;
  end;

procedure Register;

implementation
  procedure TSzogPont.Paint;
  begin
       inherited Paint;
       Canvas.Font.Assign(FFont);
       Canvas.TextOut((Width-canvas.TextWidth(FCaption)) div 2,(Height-canvas.TextHeight(FCaption)) div 2,FCaption);
  end;
  procedure TSzogPont.SetCaption(P:String);
  begin
       FCaption:=P;
       Repaint
  end;
  procedure TSzogPont.SetFont(p:TFont);
  begin
       FFont.Assign(p);
       Repaint
  end;
  procedure TSzogPont.setCX(p:integer);
  begin
       Left:=p-(Width div 2)
  end;
  procedure TSzogPont.setCY(p:integer);
  begin
       Top:=p-(Height div 2)
  end;
  function TSzogPont.readCX:integer;
  begin
       readCX:=Left+(Width div 2)
  end;
  function TSzogPont.readCY:integer;
  begin
       readCY:=Top+(Height div 2)
  end;
  constructor TSzogPont.Create(AOwner: TComponent);
  begin
    inherited Create(AOwner);
    FFont:=TFont.Create;
    Shape:=stEllipse
  end;
  destructor TSzogPont.Destroy;
  begin
    FFont:=TFont.Create;
    inherited Destroy;
  end;
procedure Register;
begin
  RegisterComponents('Standard', [TSzogPont]);
end;

end.
